
/*
 * @(#)ChatServer.java	1.11 97/02/27
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
import webflow.*;
import SharedData.*;
import SharedData.socket.*;


/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge
 */

///////////////////////////////////////////////////////////////////////////
//This module creates the ports for the WBserver in the initialize method//
//creates a whiteboard session and a channel for this session in the run //
//method and destroys the ports in the destroy method                    //  
//////////////////////////////////////////////////////////////////////////

public class
ChatWBServer1 implements ChatDebugFlags,Module{
    
    private static Stringobj sessionName;
	WhiteBoardObserver observer    = null;

IntPort chatport;
IntPort wbport;
ChatClient client;
WhiteBoardClient wbclient;
Session    chatSession ;
Session wbSession; 
    public MetaModule initialize(){
	 MetaModule mm=new MetaModule("ChatUser");
         wbport=new IntPort();
         mm.putPortID(wbport.getPortID());
         chatport=new IntPort();
          mm.putPortID(chatport.getPortID());
                  
         return(mm);
    }

    public void run() {
 client      = null;
 wbclient =null;
    //chatSession = null;
    wbSession=null;
       WhiteBoardClient   client      = null;
	String     url1         = null;
        String     url2=null;
	String     sessionType = null;
	String     hostname    = null;
	int        hostport    = 0;
        int        hostport1    = 0;
        String sessionName1;
        String sessionName2;
        if (ChatServer_Debug) {
            System.out.println("ChatServer: main.");
        }
	sessionName1=new String("ChatSession");
        sessionName2=new String("WBSession");
        hostname="osprey2";
	hostport    = 8600;//getPort(args);
        hostport1=8101;
	sessionType = "socket";//getType(args);
	url1 = "coll://" + hostname + ":" + hostport + "/" + sessionType + "/Session/" + sessionName1;
        url2 = "coll://" + hostname + ":" + hostport1 + "/" + sessionType+ "/Session/" + sessionName2; 
	try { 

/* Create a session, [re]bind it and create a channel. */
   
//   chatSession = SessionFactory.createSession(url1);
   System.out.println("creating session for chat");
   System.out.println(url1);
  // chatSession.createChannel("ChatChannel", true);
   wbSession=SessionFactory.createSession(url2);
   System.out.println(url2);
   System.out.println("creatingn session for wb");
   System.out.println("Setup and bound Whiteboard server.");
   wbSession.createChannel("WBChannel", true);
   wbclient = new WhiteBoardClient("Server");
   wbSession.join(wbclient);
//   observer =  new WhiteBoardObserver(wbclient, "Server");
//   wbSession.addObserver(observer);	
//             chatport.send(sessionName1);
	//     wbport.send(sessionName2);
	/*	boolean bool=true;
                while(true){
		if(!bool){
			chatport1.send(clientNames);
			chatport2.send(clientNames);
			bool=true;
		}
	}	*/

        } catch (SharedDataException e) {
            System.out.println("ChatServer: main: shared data exception: " + e);
            if (ChatServer_Debug) {
		e.printStackTrace();
	    }
        } 
}        
    




 
   public void destroy(){
	//chatSession=null;        //client=null;
       chatport.destroyPort();
wbport.destroyPort();
observer=null;	
     }   
   private static String
    getHost(String args[]) {
        String defHost = "stard";   /* Default host name for connections. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getHost.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-server")) {
                if (++i < length) {
                    return(args[i]);
                }
            }
        }
        return(defHost);
    }

public void stop()
{} 

    private static int
    getPort(String args[]) {
        int defPort = 4461;   /* Default port number for connections. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getPort.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-port")) {
                if (++i < length) {
                    return(Integer.parseInt(args[i]));
                }
            }    
        }
        return(defPort);
    }


    private static String
    getType(String args[]) {
        String defType = "socket";   /* Default Session type. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getType.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-type")) {
                if (++i < length) {
                    return(args[i]);
                }
            }    
        }
        return(defType);
    }
}










